import 'package:json_annotation/json_annotation.dart';
part 'json_demo.g.dart';

enum DemoCategory {
  multimedia,
  board,
  machineLearning,
}

@JsonSerializable(explicitToJson: true)
class JsonModel {
  JsonModel({
    required this.multimedia,
    required this.board,
    required this.machineLearning,
  });

  @JsonKey(name: 'Multimedia')
  Multimedia multimedia;
  @JsonKey(name: 'Board')
  Board board;
  @JsonKey(name: 'Machine Learning')
  MachineLearning machineLearning;

  factory JsonModel.fromJson(Map<String, dynamic> json) =>
      _$JsonModelFromJson(json);

  Map<String, dynamic> toJson() => _$JsonModelToJson(this);
}

@JsonSerializable(explicitToJson: true)
class Multimedia {
  Multimedia({
    required this.mediaplayer,
    required this.videoRecorder,
  });
  List<MediaPlayer> mediaplayer;
  @JsonKey(name: 'video recorder')
  List<VideoRecorder> videoRecorder;

  factory Multimedia.fromJson(Map<String, dynamic> json) =>
      _$MultimediaFromJson(json);

  Map<String, dynamic> toJson() => _$MultimediaToJson(this);
}

@JsonSerializable(explicitToJson: true)
class Board {
  Board({
    required this.boardFunction,
  });
  @JsonKey(name: 'Board function')
  List<BoardFunction> boardFunction;

  factory Board.fromJson(Map<String, dynamic> json) => _$BoardFromJson(json);

  Map<String, dynamic> toJson() => _$BoardToJson(this);
}

@JsonSerializable(explicitToJson: true)
class MachineLearning {
  MachineLearning({
    required this.tensorflowLite,
  });
  @JsonKey(name: 'Tensorflow Lite')
  List<TensorflowLite> tensorflowLite;

  factory MachineLearning.fromJson(Map<String, dynamic> json) =>
      _$MachineLearningFromJson(json);

  Map<String, dynamic> toJson() => _$MachineLearningToJson(this);
}

@JsonSerializable()
class MediaPlayer {
  MediaPlayer(
      {required this.name,
      required this.executable,
      required this.source,
      required this.icon,
      required this.screenshot,
      required this.compatible,
      required this.enDescription,
      required this.jaDescription});
  String name;
  String executable;
  String source;
  String icon;
  String screenshot;
  String compatible;
  String enDescription;
  String jaDescription;

  factory MediaPlayer.fromJson(Map<String, dynamic> json) =>
      _$MediaPlayerFromJson(json);

  Map<String, dynamic> toJson() => _$MediaPlayerToJson(this);
}

@JsonSerializable()
class VideoRecorder {
  VideoRecorder(
      {required this.name,
      required this.executable,
      required this.source,
      required this.icon,
      required this.screenshot,
      required this.compatible,
      required this.enDescription,
      required this.jaDescription});
  String name;
  String executable;
  String source;
  String icon;
  String screenshot;
  String compatible;
  String enDescription;
  String jaDescription;
  factory VideoRecorder.fromJson(Map<String, dynamic> json) =>
      _$VideoRecorderFromJson(json);

  Map<String, dynamic> toJson() => _$VideoRecorderToJson(this);
}

@JsonSerializable()
class BoardFunction {
  BoardFunction(
      {required this.name,
      required this.executable,
      required this.source,
      required this.icon,
      required this.screenshot,
      required this.compatible,
      required this.enDescription,
      required this.jaDescription});
  String name;
  String executable;
  String source;
  String icon;
  String screenshot;
  String compatible;
  String enDescription;
  String jaDescription;

  factory BoardFunction.fromJson(Map<String, dynamic> json) =>
      _$BoardFunctionFromJson(json);

  Map<String, dynamic> toJson() => _$BoardFunctionToJson(this);
}

@JsonSerializable()
class TensorflowLite {
  TensorflowLite(
      {required this.name,
      required this.executable,
      required this.source,
      required this.screenshot,
      required this.compatible,
      required this.enDescription,
      required this.jaDescription});
  String name;
  String executable;
  String source;
  String screenshot;
  String compatible;
  String enDescription;
  String jaDescription;

  factory TensorflowLite.fromJson(Map<String, dynamic> json) =>
      _$TensorflowLiteFromJson(json);

  Map<String, dynamic> toJson() => _$TensorflowLiteToJson(this);
}
