import 'dart:convert';
import 'package:flutter/services.dart' show rootBundle;
import 'package:flutter_gen/gen_l10n/l10n.dart';
import 'package:flutter_riverpod/flutter_riverpod.dart';
import 'package:process_run/shell.dart';
import 'package:flutter_demo_experience/json_demo.dart';

final demoRouteProvider = StateProvider<List<String>>((ref) => []);

final displayTitleProvider = StateProvider<List<String>>((ref) => []);

final imagePathsProvider = StateProvider<List<String>>((ref) => []);

final isExecutableDemoProvider = StateProvider<bool>((ref) => false);

final isExecutionProbider = StateProvider<bool>((ref) => false);

final jsonModelProvider = FutureProvider<JsonModel>((ref) async {
  final content = json.decode(await rootBundle.loadString('json/demos.json'));
  return JsonModel.fromJson(content);
});

final langButtonProvider = StateProvider((ref) => [true, false]);

final localeProvider = StateProvider((ref) => L10n.supportedLocales.last);

final shellProvider = StateProvider<Shell>((ref) => Shell());
