import 'package:flutter/material.dart';
import 'package:flutter_gen/gen_l10n/l10n.dart';
import 'package:flutter_demo_experience/const/colors.dart';
import 'package:flutter_demo_experience/const/dimens.dart';
import 'package:flutter_demo_experience/const/strings.dart';

class DemoSource extends StatelessWidget {
  const DemoSource({super.key});

  @override
  Widget build(BuildContext context) {
    final Size widgetSize = MediaQuery.of(context).size;
    final double fontSize = widgetSize.width * demoURLFontSizeRatio;
    return Column(
      children: [
        Text(
          '${L10n.of(context)!.getSourceDescription}\n$demoAptSource\n',
          style: TextStyle(fontSize: fontSize, color: textColor),
        ),
      ],
    );
  }
}
