import 'package:flutter/material.dart';
import 'package:flutter_gen/gen_l10n/l10n.dart';
import 'package:flutter_riverpod/flutter_riverpod.dart';
import 'package:flutter_demo_experience/provider.dart';
import 'package:flutter_demo_experience/const/colors.dart';

class LangButton extends ConsumerWidget {
  final List<String> names;
  const LangButton({Key? key, required this.names}) : super(key: key);

  @override
  Widget build(BuildContext context, WidgetRef ref) {
    final langButton = ref.watch(langButtonProvider);
    return Row(
      mainAxisAlignment: MainAxisAlignment.end,
      children: [
        ElevatedButton(
          onPressed: () {
            ref.watch(langButtonProvider.notifier).state = [true, false];
            ref.watch(localeProvider.notifier).state =
                L10n.supportedLocales.last;
          },
          style: ElevatedButton.styleFrom(
            backgroundColor:
                langButton.first ? activeButtonColor : inactiveButtonColor,
          ),
          child: Text(names.first),
        ),
        ElevatedButton(
          onPressed: () {
            ref.watch(langButtonProvider.notifier).state = [false, true];
            ref.watch(localeProvider.notifier).state =
                L10n.supportedLocales.first;
          },
          style: ElevatedButton.styleFrom(
            backgroundColor:
                langButton.last ? activeButtonColor : inactiveButtonColor,
          ),
          child: Text(names.last),
        ),
      ],
    );
  }
}
